/*
 * Copyright (c) 2015 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kniss
 *
 * This file is part of de.bsvrz.kex.tls.osi7.TlsDataTest
 *
 * de.bsvrz.kex.tls.osi7.TlsDataTest is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  de.bsvrz.kex.tls.osi7.TlsDataTest is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with de.bsvrz.kex.tls.osi7.TlsDataTest.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Diese Datei ist Teil von de.bsvrz.kex.tls.osi7.TlsDataTest.
 *
 *  de.bsvrz.kex.tls.osi7.TlsDataTest ist Freie Software: Sie knnen es unter den Bedingungen
 *  der GNU General Public License, wie von der Free Software Foundation,
 *  Version 3 der Lizenz oder (nach Ihrer Wahl) jeder spteren
 *  verffentlichten Version, weiterverbreiten und/oder modifizieren.
 *
 *  de.bsvrz.kex.tls.osi7.TlsDataTest wird in der Hoffnung, dass es ntzlich sein wird, aber
 *  OHNE JEDE GEWHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *  Gewhrleistung der MARKTFHIGKEIT oder EIGNUNG FR EINEN BESTIMMTEN ZWECK.
 *  Siehe die GNU General Public License fr weitere Details.
 *
 *  Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 *  Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * inovat, Dipl.-Ing. H. C. Kniss
 * An der Krautwiese 37
 * D-53783 Eitorf
 * +49 (0)2243 8464 193
 * info@inovat.de
 * www.inovat.de
 */

package de.bsvrz.kex.tls.osi7;

import de.bsvrz.sys.funclib.debug.Debug;
import junit.framework.*;

/**
 * Created by Kappich+Kni Systemberatung Aachen (K2S)
 *
 * @author Hans Christian Kni (HCK)
 * @version $Revision$ / $Date$ / ($Author$)
 */

public class TlsDataTest extends TestCase {

	public TlsDataTest(String testName) {
		super(testName);

	}

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public static Test suite() {
		TestSuite suite = new TestSuite(TlsDataTest.class);

		//Debug.setLoggerLevel("DEFAULT", Debug.ERROR);
		Debug.setHandlerLevel("StdErr", Debug.ALL);
		//Debug.setHandlerLevel("FileText", Debug.OFF);
		//Debug.setHandlerLevel("FileHTML", Debug.OFF);
		//Debug.setHandlerLevel("FileXML", Debug.OFF);
		//Debug.setHandlerLevel("FileExcel", Debug.OFF);

		return suite;
	}

	/**
	 *
	 */
	public void testReadHighLowByteAsHalfByteAsInt() {
		// Test alle Methoden:                     High    |   Low
		TlsData d1 = new TlsData(new byte[]{(byte) 0, (byte) 0});// 0
		TlsData d2 = new TlsData(new byte[]{(byte) 0, (byte) 1});// 1
		TlsData d3 = new TlsData(new byte[]{(byte) 0, (byte) 16});// 10
		TlsData d4 = new TlsData(new byte[]{(byte) 1, (byte) 0});// 100
		TlsData d5 = new TlsData(new byte[]{(byte) 16, (byte) 0});// 1000

		assertEquals(0, d1.readHighLowByteAsHalfByteAsInt());
		assertEquals(1, d2.readHighLowByteAsHalfByteAsInt());
		assertEquals(10, d3.readHighLowByteAsHalfByteAsInt());
		assertEquals(100, d4.readHighLowByteAsHalfByteAsInt());
		assertEquals(1000, d5.readHighLowByteAsHalfByteAsInt());

		// Systematischer Test aller Zustnde

		int e, z, h, t;
		int result;
		TlsData data;
		for (t = 0; t < 10; ++t) {
			for (h = 0; h < 10; ++h) {
				for (z = 0; z < 10; ++z) {
					for (e = 0; e < 10; ++e) {
						data = new TlsData(new byte[]{(byte) ((t << 4) + h), (byte) ((z << 4) + e)});
						result = t * 1000 + h * 100 + z * 10 + e;
						assertEquals(result, data.readHighLowByteAsHalfByteAsInt());

					}
				}
			}
		}

	}

	/**
	 *
	 */
	public void testReadExtraHighHighLowByteAsHalfByteAsInt() {
		// Test alle Methoden:               Extra |      High    |   Low
		TlsData d1 = new TlsData(new byte[]{(byte) 0, (byte) 0, (byte) 0});// 0
		TlsData d2 = new TlsData(new byte[]{(byte) 0, (byte) 0, (byte) 1});// 1
		TlsData d3 = new TlsData(new byte[]{(byte) 0, (byte) 0, (byte) 16});// 10
		TlsData d4 = new TlsData(new byte[]{(byte) 0, (byte) 1, (byte) 0});// 100
		TlsData d5 = new TlsData(new byte[]{(byte) 0, (byte) 16, (byte) 0});// 1000
		TlsData d6 = new TlsData(new byte[]{(byte) 1, (byte) 0, (byte) 0});// 10000
		TlsData d7 = new TlsData(new byte[]{(byte) 16, (byte) 0, (byte) 0});// 100000

		assertEquals(0, d1.readExtraHighHighLowByteAsHalfByteAsInt());
		assertEquals(1, d2.readExtraHighHighLowByteAsHalfByteAsInt());
		assertEquals(10, d3.readExtraHighHighLowByteAsHalfByteAsInt());
		assertEquals(100, d4.readExtraHighHighLowByteAsHalfByteAsInt());
		assertEquals(1000, d5.readExtraHighHighLowByteAsHalfByteAsInt());
		assertEquals(10000, d6.readExtraHighHighLowByteAsHalfByteAsInt());
		assertEquals(100000, d7.readExtraHighHighLowByteAsHalfByteAsInt());

		// Systematischer Test aller Zustnde

		int e, z, h, t, zt, ht;
		int result;
		TlsData data;
		for (ht = 0; ht < 10; ++ht) {
			for (zt = 0; zt < 10; ++zt) {
				for (t = 0; t < 10; ++t) {
					for (h = 0; h < 10; ++h) {
						for (z = 0; z < 10; ++z) {
							for (e = 0; e < 10; ++e) {
								data = new TlsData(new byte[]{(byte) ((ht << 4) + zt),
								                              (byte) ((t << 4) + h),
								                              (byte) ((z << 4) + e)});
								result = ht * 100000 + zt * 10000 + t * 1000 + h * 100 + z * 10 + e;
								assertEquals(result, data.readExtraHighHighLowByteAsHalfByteAsInt());

							}
						}
					}
				}
			}
		}

	}

	/**
	 *
	 */
	public void testReadLowOrLowHighByteAsInt() {
		// Test alle Methoden:                     Low    |   High
		TlsData d1 = new TlsData(new byte[]{(byte) 128, (byte) 0});// 0
		TlsData d2 = new TlsData(new byte[]{(byte) 1, (byte) 0});// 1
		TlsData d3 = new TlsData(new byte[]{(byte) 0, (byte) 1});// 128
		TlsData d4 = new TlsData(new byte[]{(byte) 129, (byte) 22});// 1
		TlsData d5 = new TlsData(new byte[]{(byte) 127, (byte) 255});// 32766

		assertEquals(0, d1.readUnsignedLowOrLowHighByteAsInt());
		assertEquals(1, d2.readUnsignedLowOrLowHighByteAsInt());
		assertEquals(128, d3.readUnsignedLowOrLowHighByteAsInt());
		assertEquals(1, d4.readUnsignedLowOrLowHighByteAsInt());
		assertEquals(32767, d5.readUnsignedLowOrLowHighByteAsInt());

	}

	public void testReadTlsData() {
		// Test alle Methoden:                   Lnge         Low       Lnge         Low        High   ExtraHiht
		TlsData d1 = new TlsData(new byte[]{(byte) 001, (byte) 002, (byte) 003, (byte) 001, (byte) 002, (byte) 003});

		TlsData data;

		data = d1.readNextTlsDataBlock();
		assertEquals(1, d1.lastReadPosition());// 1, weil intern schon Lngenbyte gelesen wurde !!
		assertEquals(2, d1.currentReadPosition());
		assertEquals(1, data.length());

		assertEquals(2, data.readUnsignedByteAsInt());

		data = d1.readNextTlsDataBlock();
		assertEquals(3, d1.lastReadPosition());// 3, weil intern schon Lngenbyte gelesen wurde !!
		assertEquals(6, d1.currentReadPosition());
		assertEquals(3, data.length());

		assertEquals(1, data.readUnsignedByteAsInt());
		assertEquals(2, data.readUnsignedByteAsInt());
		assertEquals(3, data.readUnsignedByteAsInt());

		d1.rewindReadPosition();// Test mit Lngenangabe

		data = d1.readNextTlsDataBlock(d1.readUnsignedByteAsInt());
		assertEquals(1, d1.lastReadPosition());
		assertEquals(2, d1.currentReadPosition());
		assertEquals(1, data.length());

		assertEquals(2, data.readUnsignedByteAsInt());

		data = d1.readNextTlsDataBlock(d1.readUnsignedByteAsInt());
		assertEquals(3, d1.lastReadPosition());
		assertEquals(6, d1.currentReadPosition());
		assertEquals(3, data.length());

		assertEquals(1, data.readUnsignedByteAsInt());
		assertEquals(2, data.readUnsignedByteAsInt());
		assertEquals(3, data.readUnsignedByteAsInt());

	}

	public void testReadXXXAsInt() {
		// Test alle Methoden:                     Low    |    Low        High    |    Low        High   ExtraHiht
		TlsData d1 = new TlsData(new byte[]{(byte) 000, (byte) 000, (byte) 000, (byte) 000, (byte) 000, (byte) 000});
		TlsData d2 = new TlsData(new byte[]{(byte) 001, (byte) 001, (byte) 000, (byte) 001, (byte) 000, (byte) 000});
		TlsData d3 = new TlsData(new byte[]{(byte) 127, (byte) 127, (byte) 000, (byte) 127, (byte) 000, (byte) 000});
		TlsData d4 = new TlsData(new byte[]{(byte) 128, (byte) 128, (byte) 000, (byte) 128, (byte) 000, (byte) 000});
		TlsData d5 = new TlsData(new byte[]{(byte) 255, (byte) 255, (byte) 000, (byte) 255, (byte) 000, (byte) 000});

		// Signed Funktionen testen
		assertEquals(0, d1.readSignedByteAsInt());
		assertEquals(1, d2.readSignedByteAsInt());
		assertEquals(127, d3.readSignedByteAsInt());
		assertEquals(-128, d4.readSignedByteAsInt());
		assertEquals(-1, d5.readSignedByteAsInt());
		d1.rewindReadPosition();
		d2.rewindReadPosition();
		d3.rewindReadPosition();
		d4.rewindReadPosition();
		d5.rewindReadPosition();
		assertEquals(0, d1.readSignedLowHighByteAsInt());
		assertEquals(257, d2.readSignedLowHighByteAsInt());
		assertEquals(32639, d3.readSignedLowHighByteAsInt());
		assertEquals(-32640, d4.readSignedLowHighByteAsInt());
		assertEquals(-1, d5.readSignedLowHighByteAsInt());
		d1.rewindReadPosition();
		d2.rewindReadPosition();
		d3.rewindReadPosition();
		d4.rewindReadPosition();
		d5.rewindReadPosition();

		//d1 testen
		assertEquals(0, d1.readUnsignedByteAsInt());
		assertEquals(0, d1.readUnsignedLowHighByteAsInt());
		d1.backStepReadPosition();
		assertEquals(0, d1.readUnsignedHighLowByteAsInt());
		assertEquals(0, d1.readUnsignedLowHighExtraHighByteAsInt());
		d1.backStepReadPosition();
		assertEquals(0, d1.readUnsignedExtraHighHighLowByteAsInt());
		// Interne Zustnde von _aktPos und _lastPos prfen
		assertEquals(6, d1.currentReadPosition());
		assertEquals(3, d1.lastReadPosition());
		d1.rewindReadPosition();
		assertEquals(0, d1.currentReadPosition());
		assertEquals(0, d1.lastReadPosition());

		// d2 testen
		assertEquals(1, d2.readUnsignedByteAsInt());
		assertEquals(1, d2.readUnsignedLowHighByteAsInt());
		d2.backStepReadPosition();
		assertEquals(256, d2.readUnsignedHighLowByteAsInt());
		assertEquals(1, d2.readUnsignedLowHighExtraHighByteAsInt());
		d2.backStepReadPosition();
		assertEquals(65536, d2.readUnsignedExtraHighHighLowByteAsInt());

		// d3 testen
		assertEquals(127, d3.readUnsignedByteAsInt());
		assertEquals(127, d3.readUnsignedLowHighByteAsInt());
		d3.backStepReadPosition();
		assertEquals(32512, d3.readUnsignedHighLowByteAsInt());
		assertEquals(127, d3.readUnsignedLowHighExtraHighByteAsInt());
		d3.backStepReadPosition();
		assertEquals(8323072, d3.readUnsignedExtraHighHighLowByteAsInt());

		// d4 testen
		assertEquals(128, d4.readUnsignedByteAsInt());
		assertEquals(128, d4.readUnsignedLowHighByteAsInt());
		d4.backStepReadPosition();
		assertEquals(32768, d4.readUnsignedHighLowByteAsInt());
		assertEquals(128, d4.readUnsignedLowHighExtraHighByteAsInt());
		d4.backStepReadPosition();
		assertEquals(8388608, d4.readUnsignedExtraHighHighLowByteAsInt());

		// d5 testen
		assertEquals(255, d5.readUnsignedByteAsInt());
		assertEquals(255, d5.readUnsignedLowHighByteAsInt());
		d5.backStepReadPosition();
		assertEquals(65280, d5.readUnsignedHighLowByteAsInt());
		assertEquals(255, d5.readUnsignedLowHighExtraHighByteAsInt());
		d5.backStepReadPosition();
		assertEquals(16711680, d5.readUnsignedExtraHighHighLowByteAsInt());

		// Systematischer Test aller Zustnde

		int l, h, e;
		int resultByte, resultByteByte, resultByteByteByte;
		TlsData data;
		for (e = 0; e < 256; ++e) {
			for (h = 0; h < 256; ++h) {
				for (l = 0; l < 256; ++l) {
					data = new TlsData(new byte[]{(byte) l, (byte) h, (byte) e});

					resultByte = l;
					resultByteByte = l + (256 * h);
					resultByteByteByte = l + (256 * h) + (65536 * e);

					assertEquals(resultByte, data.readUnsignedByteAsInt());
					data.backStepReadPosition();
					assertEquals(resultByteByte, data.readUnsignedLowHighByteAsInt());
					data.backStepReadPosition();
					assertEquals(resultByteByteByte, data.readUnsignedLowHighExtraHighByteAsInt());

				}
			}

		}

		for (e = 0; e < 256; ++e) {
			for (h = 0; h < 256; ++h) {
				for (l = 0; l < 256; ++l) {
					data = new TlsData(new byte[]{(byte) e, (byte) h, (byte) l});

					resultByte = e;
					resultByteByte = l + (256 * h);
					resultByteByteByte = l + (256 * h) + (65536 * e);

					assertEquals(resultByte, data.readUnsignedByteAsInt());
					assertEquals(resultByteByte, data.readUnsignedHighLowByteAsInt());
					data.rewindReadPosition();
					assertEquals(resultByteByteByte, data.readUnsignedExtraHighHighLowByteAsInt());

				}
			}

		}

	}
}
